'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class;

var _decko = require('decko');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

/**
 * A tiny JavaScript carousel
 */
var MagicRoundabout = (_class = function () {

  /**
   * Create the slideshow instance
   *
   * @param {HTMLElement|string} target
   * @param {object} opts
   */


  /**
   * The width of the slideshow container
   *
   * @type {int}
   */

  /**
   * Options for the instance
   *
   * @type {object}
   */
  function MagicRoundabout(target, opts) {
    var _this = this;

    _classCallCheck(this, MagicRoundabout);

    this.opts = {
      auto: false,
      buttons: true,
      center: false,
      click: true,
      delay: 10000,
      draggable: false,
      duplicateSlidesWhenLooping: false,
      duplicateSlidesCount: 1,
      keys: true,
      limit: false,
      loop: true,
      onChange: function onChange() {},
      touch: true,
      scroll: true,
      slidesPerView: 1,
      vertical: false

      /**
       * The real index of the current slide
       *
       * @type {int}
       */
    };
    this._current = 0;
    this.width = null;
    this.touch = null;

    if (typeof target === 'string') {
      target = document.querySelector(target);
    }

    this.opts = _extends({}, this.opts, opts);

    this.container = target;
    this.wrapper = this.container.querySelector('.slideshow__slides');

    // Some HTML caching systems may leave duplicated slides in place when the
    // page loads. We clear them here to prevent duplicating the duplicates
    this.wrapper.querySelectorAll('.slideshow__slide--duplicate').forEach(function (slide) {
      slide.parentNode.removeChild(slide);
    });

    this.slides = Array.from(this.container.querySelectorAll('.slideshow__slide'));
    var i = 1;
    this.slides.forEach(function (slide) {
      slide.dataset.index = i++;
    });

    if (this.opts.loop && this.opts.duplicateSlidesWhenLooping) {
      this.duplicatesAppend = this.slides.slice(0, this.opts.duplicateSlidesCount).map(function (slide) {
        return slide.cloneNode(true);
      });
      this.duplicatesAppend.forEach(function (duplicate) {
        duplicate.classList.add('slideshow__slide--duplicate');
        duplicate.dataset.index = parseInt(duplicate.dataset.index) + _this.slides.length;
        _this.wrapper.appendChild(duplicate);
      });

      this.duplicatesPrepend = this.slides.slice(0 - this.opts.duplicateSlidesCount).map(function (slide) {
        return slide.cloneNode(true);
      });
      this.duplicatesPrepend.reverse().forEach(function (duplicate) {
        duplicate.classList.add('slideshow__slide--duplicate');
        duplicate.dataset.index = parseInt(duplicate.dataset.index) - _this.slides.length;
        _this.wrapper.insertBefore(duplicate, _this.wrapper.childNodes[0]);
      });
    }

    if (this.opts.buttons) {
      this.buttons = {};
      this.buttons.next = this.container.querySelector('.slideshow__button--next');
      this.buttons.prev = this.container.querySelector('.slideshow__button--prev');
    }

    this.setContainerSize();
    this.registerListeners();

    this.current = 1;
  }

  /**
   * Get the current slide index
   *
   * @return {int}
   */


  /**
   * An object used for storing touch coordinates
   *
   * @type {object}
   */


  _createClass(MagicRoundabout, [{
    key: 'applyClasses',
    value: function applyClasses() {
      var _this2 = this;

      var elements = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var i = arguments[1];

      if (elements.length === 0) {
        return;
      }

      requestAnimationFrame(function (t) {
        var k = _this2.opts.slidesPerView;
        var selected = [];

        if (i >= 0) {
          elements.slice(i, i + k).forEach(function (slide) {
            slide.classList.remove('slideshow__slide--next');
            slide.classList.remove('slideshow__slide--prev');
            slide.classList.add('slideshow__slide--active');
            selected.push(slide);
          });
        }

        if (i >= k) {
          elements.slice(i - k, i).forEach(function (slide) {
            slide.classList.remove('slideshow__slide--next');
            slide.classList.remove('slideshow__slide--active');
            slide.classList.add('slideshow__slide--prev');
            selected.push(slide);
          });
        }

        if (i + k >= 0) {
          elements.slice(i + k, i + k + k).forEach(function (slide) {
            slide.classList.remove('slideshow__slide--active');
            slide.classList.remove('slideshow__slide--prev');
            slide.classList.add('slideshow__slide--next');
            selected.push(slide);
          });
        }

        _this2.clearState(elements.filter(function (slide) {
          return selected.indexOf(slide) === -1;
        }));
      });
    }

    /**
     * Trigger a delayed instant transition, to allow us to silently flick from
     * a duplicated slide to its corresponding slide in the main list
     *
     * @param {int} i
     */

  }, {
    key: 'changeInstantly',
    value: function changeInstantly(i) {
      var _this3 = this;

      // Prevent interaction to avoid the user navigating to a slide that does
      // not exist
      this.transitioning = true;

      var delay = getComputedStyle(this.wrapper).transitionDelay;
      var delayFloat = parseFloat(delay, 10) * 1000;
      var duration = getComputedStyle(this.wrapper).transitionDuration;
      var durationFloat = parseFloat(duration, 10) * 1000;

      setTimeout(function () {
        _this3.wrapper.style.transitionDelay = '0s';
        _this3.wrapper.style.transitionDuration = '0s';

        _this3.current = i;
        _this3.transitioning = false;

        setTimeout(function () {
          _this3.wrapper.style.transitionDelay = null;
          _this3.wrapper.style.transitionDuration = null;
        }, 50);
      }, delayFloat + durationFloat);
    }

    /**
     * Clear a slide state completely
     *
     * @param {NodeList|Array} slides
     *
     * @return {NodeList|Array}
     */

  }, {
    key: 'clearState',
    value: function clearState(slides) {
      requestAnimationFrame(function (t) {
        slides.forEach(function (slide) {
          slide.classList.remove('slideshow__slide--active');
          slide.classList.remove('slideshow__slide--next');
          slide.classList.remove('slideshow__slide--prev');
        });
      });
    }

    /**
     * Register listeners to handle user interactions
     */

  }, {
    key: 'registerListeners',
    value: function registerListeners() {
      var _this4 = this;

      // Set the container size
      window.addEventListener('resize', this.setContainerSize);

      // Handle scroll events
      if (this.opts.scroll) {
        this.container.addEventListener('wheel', this.handleScroll);
      }

      // Handle swipe events
      if (this.opts.touch) {
        this.container.addEventListener('touchstart', this.handleTouchStart);
        this.container.addEventListener('touchmove', this.handleTouchMove);
        this.container.addEventListener('mousedown', this.handleMouseDown);
        this.container.addEventListener('mousemove', this.handleMouseMove);
        this.container.addEventListener('mouseup', this.handleMouseUp);
      }

      // Handle keyboard events
      if (this.opts.keys) {
        document.addEventListener('keyup', this.handleKeypress);
      }

      // Slide to clicked slide
      if (this.opts.click) {
        var fn = function fn(slide) {
          slide.addEventListener('click', function (e) {
            _this4.current = slide.dataset.index;
          });
        };
        this.slides.forEach(fn);

        if (this.opts.loop && this.opts.duplicateSlidesWhenLooping) {
          this.duplicatesAppend.forEach(fn);
          this.duplicatesPrepend.forEach(fn);
        }
      }

      // Handle pagination buttons
      if (this.opts.buttons) {
        this.buttons.next.addEventListener('click', function (e) {
          _this4.current = _this4.current + _this4.opts.slidesPerView;
        });

        this.buttons.prev.addEventListener('click', function (e) {
          _this4.current = _this4.current - _this4.opts.slidesPerView;
        });
      }
    }

    /**
     * Update the container width when the window resizes
     */

  }, {
    key: 'setContainerSize',
    value: function setContainerSize() {
      this.width = this.container.clientWidth;
      this.transition();
    }

    /**
     * Handle scroll events on the container
     *
     * @param {WheelEvent} e
     */

  }, {
    key: 'handleScroll',
    value: function handleScroll(e) {
      if (this.opts.vertical && Math.abs(e.deltaY) > Math.abs(e.deltaX)) {
        return this.handleDeltaChange(e, e.deltaY, true);
      }

      if (!this.opts.vertical && Math.abs(e.deltaX) > Math.abs(e.deltaY)) {
        return this.handleDeltaChange(e, e.deltaX, true);
      }
    }

    /**
     * Handle touchstart events on the container
     *
     * @param {TouchEvent} e
     */

  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(e) {
      this.touch = { x: e.touches[0].clientX, y: e.touches[0].clientY };
    }

    /**
     * Convert mousedown events to touchstart events
     *
     * @param {MousedownEvent} e
     */

  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(e) {
      e.touches = [{ clientX: e.clientX, clientY: e.clientY }];
      return this.handleTouchStart(e);
    }

    /**
     * Handle touchend events on the container
     *
     * @param {TouchEvent} e
     */

  }, {
    key: 'handleTouchMove',
    value: function handleTouchMove(e) {
      clearTimeout(this.touchEndHandler);

      // If a touch hasn't been recorded, we can't calculate the distance,
      // so we ignore the movement
      if (!this.touch) {
        return;
      }

      // If there are multiple touches, ignore them so that we don't
      // interfere with pinch-to-zoom
      if (e.touches.length > 1) {
        return;
      }

      if (!this.opts.draggable) {
        this.touchEndHandler = setTimeout(this.handleTouchEnd.bind(this, e), 50);
        return;
      }

      if (!this.transitioning) {
        var x = e.touches[0].clientX;
        var y = e.touches[0].clientY;

        var deltaX = this.touch.x - x;
        var deltaY = this.touch.y - y;

        // If the user has dragged more than the current slides width, reset the
        // touch point and silently update the current slide
        if (this.opts.vertical && Math.abs(deltaY) > this.getOuterHeight(this.slides[this._current])) {
          this.touch.y = y;
          if (deltaY < 0) {
            this._current = this._current - this.opts.slidesPerView;
          } else {
            this._current = this._current + this.opts.slidesPerView;
          }
        }

        if (!this.opts.vertical && Math.abs(deltaX) > this.getOuterWidth(this.slides[this._current])) {
          this.touch.x = x;
          if (deltaX < 0) {
            this._current = this._current - this.opts.slidesPerView;
          } else {
            this._current = this._current + this.opts.slidesPerView;
          }
        }

        if (this.opts.vertical && Math.abs(deltaY) > Math.abs(deltaX)) {
          this.offsetTransition(deltaY);
        }

        if (!this.opts.vertical && Math.abs(deltaX) > Math.abs(deltaY)) {
          this.offsetTransition(deltaX);
        }

        this.touchEndHandler = setTimeout(this.handleTouchEnd.bind(this, e), 300);
      }
    }

    /**
     * Convert mousemove events to touchmove events
     *
     * @param {MousemoveEvent} e
     */

  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(e) {
      e.touches = [{ clientX: e.clientX, clientY: e.clientY }];
      return this.handleTouchMove(e);
    }

    /**
     * Handle touchend events on the container
     *
     * @param {TouchEvent} e
     */

  }, {
    key: 'handleTouchEnd',
    value: function handleTouchEnd(e) {
      // If a touch hasn't been recorded, we can't calculate the distance,
      // so we ignore the movement
      if (!this.touch) {
        return;
      }

      // If there are multiple touches, ignore them so that we don't
      // interfere with pinch-to-zoom
      if (e.touches.length > 1) {
        return;
      }

      var x = e.touches[0].clientX;
      var y = e.touches[0].clientY;

      var deltaX = this.touch.x - x;
      var deltaY = this.touch.y - y;

      this.touch = null;

      // Reset transition timing
      this.wrapper.style.transitionDelay = null;
      this.wrapper.style.transitionDuration = null;

      if (this.opts.vertical && Math.abs(deltaY) > Math.abs(deltaX)) {
        if (this.opts.draggable) {
          if (Math.abs(deltaY) > this.getOuterHeight(this.slides[this._current]) / 2) {
            return this.handleDeltaChange(e, deltaY, false);
          }
        }

        return this.handleDeltaChange(e, deltaY, false);
      }

      if (!this.opts.vertical && Math.abs(deltaX) > Math.abs(deltaY)) {
        if (this.opts.draggable) {
          if (Math.abs(deltaX) > this.getOuterWidth(this.slides[this._current]) / 2) {
            return this.handleDeltaChange(e, deltaX, false);
          }
        }

        return this.handleDeltaChange(e, deltaX, false);
      }
    }

    /**
     * Convert mouseup events to touchend events
     *
     * @param {MouseupEvent} e
     */

  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp(e) {
      e.touches = [{ clientX: e.clientX, clientY: e.clientY }];
      return this.handleTouchEnd(e);
    }

    /**
     * Handle a swipe or scroll interaction
     *
     * @param {WheelEvent|TouchEvent} e
     * @param {int} distance
     * @param {bool} preventInteraction
     */

  }, {
    key: 'handleDeltaChange',
    value: function handleDeltaChange(e, distance) {
      var _this5 = this;

      var preventInteraction = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (this.transitioning) {
        e.stopPropagation();
        e.preventDefault();
        e.cancelBubble = true;
        return false;
      }

      var n = this.current;

      this.transitioning = true;

      e.stopPropagation();
      e.preventDefault();
      e.cancelBubble = true;

      if (distance > 0) {
        this.current = n + this.opts.slidesPerView;
      }

      if (distance < 0) {
        this.current = n - this.opts.slidesPerView;
      }

      if (preventInteraction) {
        setTimeout(function () {
          _this5.transitioning = false;
        }, 1250);

        return false;
      }

      this.transitioning = false;

      return false;
    }

    /**
     * Handle keypresses on arrows whilst the slideshow is within the viewport
     *
     * @param {KeyboardEvent} e
     */

  }, {
    key: 'handleKeypress',
    value: function handleKeypress(e) {
      if (!this.isInViewport()) {
        return;
      }

      var keys = {
        left: 37,
        up: 38,
        right: 39,
        down: 40
      };

      var key = e.keyCode || e.which;

      if (this.opts.vertical) {
        if (key === keys.up) {
          this.current = this.current - this.opts.slidesPerView;
        }

        if (key === keys.down) {
          this.current = this.current + this.opts.slidesPerView;
        }

        return;
      }

      if (key === keys.left) {
        this.current = this.current - this.opts.slidesPerView;
      }

      if (key === keys.right) {
        this.current = this.current + this.opts.slidesPerView;
      }
    }

    /**
     * Get the correct transition offset for the current slide
     *
     * @return Number
     */

  }, {
    key: 'getTransitionOffset',
    value: function getTransitionOffset() {
      var size = this.opts.vertical ? this.getOuterHeight : this.getOuterWidth;
      var innerSize = this.opts.vertical ? this.getInnerHeight : this.getInnerWidth;

      var offset = 0;

      if (this.opts.loop && this.opts.duplicateSlidesWhenLooping) {
        this.duplicatesPrepend.slice(0, this.duplicatesPrepend.length + Math.min(this._current, 0)).forEach(function (duplicate) {
          offset += size(duplicate);
        });
      }

      for (var i = 0; i < this._current; i++) {
        offset += size(this.slides[i]);
      }

      if (this.opts.center && !this.opts.limit) {
        offset = offset + size(this.container) / 2 - innerSize(this.slides[this._current]) / 2;
      }

      if (this.opts.limit && !this.opts.loop) {
        var total = 0;
        for (var k = 0; k < this.slides.length; k++) {
          total += size(this.slides[k]);
        }

        offset = Math.min(offset, total - this.container.clientWidth);

        if (this.opts.buttons) {
          if (offset >= total - this.container.clientWidth) {
            this.buttons.next.classList.add('slideshow__button--disabled');
          } else {
            this.buttons.next.classList.remove('slideshow__button--disabled');
          }
        }
      }

      return offset * -1;
    }

    /**
     * Transition to the current slide
     */

  }, {
    key: 'transition',
    value: function transition() {
      var _this6 = this;

      var axis = this.opts.vertical ? 'translateY' : 'translateX';

      requestAnimationFrame(function (t) {
        _this6.wrapper.style.transform = axis + '(' + _this6.getTransitionOffset() + 'px)';
      });
    }

    /**
     * Offset the current transition position by the current pixel amount
     *
     * @param {Number} distance
     */

  }, {
    key: 'offsetTransition',
    value: function offsetTransition(distance) {
      var _this7 = this;

      var axis = this.opts.vertical ? 'translateY' : 'translateX';
      this.wrapper.style.transitionDelay = '0s';
      this.wrapper.style.transitionDuration = '0s';

      requestAnimationFrame(function (t) {
        _this7.wrapper.style.transform = axis + '(' + (_this7.getTransitionOffset() - distance) + 'px)';
      });
    }

    /**
     * Get the width of an element including padding, border and margin
     *
     * @param {HTMLElement} el
     *
     * @return {float}
     */

  }, {
    key: 'getOuterWidth',
    value: function getOuterWidth(el) {
      var style = window.getComputedStyle(el);

      return this.getInnerWidth(el) + parseFloat(style.marginLeft) + parseFloat(style.marginRight);
    }

    /**
     * Get the height of an element including padding, border and margin
     *
     * @param {HTMLElement} el
     *
     * @return {float}
     */

  }, {
    key: 'getOuterHeight',
    value: function getOuterHeight(el) {
      var style = window.getComputedStyle(el);

      return this.getInnerHeight(el) + parseFloat(style.marginTop) + parseFloat(style.marginBottom);
    }

    /**
     * Get the width of an element including padding, border and margin
     *
     * @param {HTMLElement} el
     *
     * @return {float}
     */

  }, {
    key: 'getInnerWidth',
    value: function getInnerWidth(el) {
      return parseFloat(el.getBoundingClientRect().width);
    }

    /**
     * Get the height of an element including padding, border and margin
     *
     * @param {HTMLElement} el
     *
     * @return {float}
     */

  }, {
    key: 'getInnerHeight',
    value: function getInnerHeight(el) {
      return parseFloat(el.getBoundingClientRect().height);
    }

    /**
     * Check if the slider is currently within the viewport
     *
     * @return {bool}
     */

  }, {
    key: 'isInViewport',
    value: function isInViewport() {
      var _container$getBoundin = this.container.getBoundingClientRect(),
          top = _container$getBoundin.top,
          left = _container$getBoundin.left,
          bottom = _container$getBoundin.bottom,
          right = _container$getBoundin.right;

      return top <= window.innerHeight && bottom >= 0 && left <= window.innerWidth && right >= 0;
    }
  }, {
    key: 'current',
    get: function get() {
      return this._current + 1;
    }

    /**
     * Set the current slide index
     *
     * @param {int} i
     */
    ,
    set: function set(i) {
      var _this8 = this;

      var fn = void 0;
      clearTimeout(this.auto);
      i = parseInt(i);
      i = i - (i - 1) % this.opts.slidesPerView;

      if (i < 1) {
        if (this.opts.loop) {
          if (!this.opts.duplicateSlidesWhenLooping) {
            i = this.slides.length - this.opts.slidesPerView + 1;
          } else {
            this.changeInstantly(this.slides.length);
          }
        } else {
          i = 1;
        }
      }

      if (i > this.slides.length - i % this.opts.slidesPerView) {
        if (this.opts.loop) {
          if (!this.opts.duplicateSlidesWhenLooping) {
            i = 1;
          } else {
            this.changeInstantly(1);
          }
        } else {
          i = this.slides.length - i % this.opts.slidesPerView;
        }
      }

      if (this.opts.buttons && !this.opts.loop) {
        fn = i === 1 ? 'add' : 'remove';
        this.buttons.prev.classList[fn]('slideshow__button--disabled');

        fn = i === this.slides.length ? 'add' : 'remove';
        this.buttons.next.classList[fn]('slideshow__button--disabled');
      }

      this._current = i - 1;
      this.transition();

      this.opts.onChange(this);

      this.applyClasses(this.slides, this._current);

      if (this.opts.loop && this.opts.duplicateSlidesWhenLooping) {
        this.applyClasses(this.duplicatesAppend, this._current - this.slides.length);
        this.applyClasses(this.duplicatesPrepend, this._current + this.slides.length - this.duplicatesPrepend.length - 1);
      }

      if (this.opts.auto) {
        this.auto = setTimeout(function () {
          _this8.current = _this8.current + _this8.opts.slidesPerView;
        }, this.opts.delay);
      }
    }

    /**
     * Apply classes to the active (or its equivalent duplicate) slide,
     * and the surrounding next and previous slides
     *
     * @param {Array} elements
     * @param {int} i
     */

  }]);

  return MagicRoundabout;
}(), (_applyDecoratedDescriptor(_class.prototype, 'applyClasses', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'applyClasses'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'changeInstantly', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'changeInstantly'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'clearState', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'clearState'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'registerListeners', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'registerListeners'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setContainerSize', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'setContainerSize'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleScroll', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleScroll'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTouchStart', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTouchStart'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleMouseDown', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleMouseDown'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTouchMove', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTouchMove'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleMouseMove', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleMouseMove'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTouchEnd', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTouchEnd'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleMouseUp', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleMouseUp'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleDeltaChange', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleDeltaChange'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleKeypress', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleKeypress'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'transition', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'transition'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'offsetTransition', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'offsetTransition'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getOuterWidth', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'getOuterWidth'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getOuterHeight', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'getOuterHeight'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getInnerWidth', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'getInnerWidth'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getInnerHeight', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'getInnerHeight'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'isInViewport', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'isInViewport'), _class.prototype)), _class);
exports.default = MagicRoundabout;